'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
function createConfig(options) {
	console.log('Building Babel config...');
	var config = {
		presets: ['env', 'stage-0'],
		plugins: ['syntax-dynamic-import', 'dynamic-import-node', ['transform-runtime', {
			polyfill: false,
			regenerator: true
		}]]
	};
	if (!options['no-react']) {
		config.presets.push('react');
		if (!options['no-css']) {
			config.plugins.unshift(['styled-jsx/babel', {
				plugins: ['styled-jsx-plugin-postcss']
			}]);
		}
	}
	return config;
}

exports.default = createConfig;
//# sourceMappingURL=config.js.map