'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getSrc = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.next = 2;
						return (0, _fsExtra.pathExists)('dev');

					case 2:
						if (!_context.sent) {
							_context.next = 4;
							break;
						}

						return _context.abrupt('return', 'dev');

					case 4:
						_context.next = 6;
						return (0, _fsExtra.pathExists)('src');

					case 6:
						if (!_context.sent) {
							_context.next = 8;
							break;
						}

						return _context.abrupt('return', 'src');

					case 8:
						return _context.abrupt('return', false);

					case 9:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, this);
	}));

	return function getSrc() {
		return _ref.apply(this, arguments);
	};
}();

var bundle = function () {
	var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(options) {
		var args, promises;
		return _regenerator2.default.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						args = [];

						if (options.src) {
							_context2.next = 7;
							break;
						}

						_context2.next = 4;
						return getSrc();

					case 4:
						options.src = _context2.sent;

						if (!options.src) {
							console.error('No src directory found');
							process.exit(1);
						}
						console.log('Found source directory');

					case 7:
						if ((0, _path.extname)(options.src)) {
							_context2.next = 20;
							break;
						}

						_context2.next = 10;
						return (0, _fsExtra.pathExists)(options.src + '/index.html');

					case 10:
						if (!_context2.sent) {
							_context2.next = 15;
							break;
						}

						console.log('Found index.html file');
						options.src = options.src + '/index.html';
						_context2.next = 20;
						break;

					case 15:
						_context2.next = 17;
						return (0, _fsExtra.pathExists)(options.src + '/index.js');

					case 17:
						if (!_context2.sent) {
							_context2.next = 20;
							break;
						}

						console.log('Found index.js file');
						options.src = options.src + '/index.js';

					case 20:
						if (options.dist) {
							_context2.next = 24;
							break;
						}

						_context2.next = 23;
						return (0, _getDist2.default)(options.src);

					case 23:
						options.dist = _context2.sent;

					case 24:
						args.push('--out-dir', '"' + options.dist + '"');
						promises = [(0, _fsExtra.remove)(options.dist)];

						if (!options['no-config']) {
							promises.push((0, _copyConfig2.default)(options), (0, _copyConfig4.default)(options));
						}
						if (options.global) {
							args.push('--global', options.global);
						}
						_context2.next = 30;
						return Promise.all(promises);

					case 30:
						(0, _childProcessPromise.spawn)('parcel build ' + options.src, args, {
							shell: true,
							stdio: 'inherit'
						});

					case 31:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, this);
	}));

	return function bundle(_x) {
		return _ref2.apply(this, arguments);
	};
}();

var _childProcessPromise = require('child-process-promise');

var _fsExtra = require('fs-extra');

var _path = require('path');

var _copyConfig = require('./babel/copy-config');

var _copyConfig2 = _interopRequireDefault(_copyConfig);

var _copyConfig3 = require('./postcss/copy-config');

var _copyConfig4 = _interopRequireDefault(_copyConfig3);

var _getDist = require('./get-dist');

var _getDist2 = _interopRequireDefault(_getDist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = bundle;
//# sourceMappingURL=bundle.js.map