'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getSrc = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.next = 2;
						return (0, _fsExtra.pathExists)('dev');

					case 2:
						if (!_context.sent) {
							_context.next = 4;
							break;
						}

						return _context.abrupt('return', 'dev');

					case 4:
						_context.next = 6;
						return (0, _fsExtra.pathExists)('src');

					case 6:
						if (!_context.sent) {
							_context.next = 8;
							break;
						}

						return _context.abrupt('return', 'src');

					case 8:
						return _context.abrupt('return', false);

					case 9:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, this);
	}));

	return function getSrc() {
		return _ref.apply(this, arguments);
	};
}();

var dev = function () {
	var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(options) {
		var args, cmd;
		return _regenerator2.default.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						args = [];

						if (options.src) {
							_context2.next = 7;
							break;
						}

						_context2.next = 4;
						return getSrc();

					case 4:
						options.src = _context2.sent;

						if (!options.src) {
							console.error('No src directory found');
							process.exit(1);
						}
						console.log('Found source directory');

					case 7:
						if (!options.dist) {
							if (options.src === 'src') {
								options.dist = 'dist';
							} else {
								options.dist = 'dist-' + options.src;
							}
						}
						args.push('--out-dir', '"' + options.dist + '"');
						_context2.next = 11;
						return (0, _fsExtra.pathExists)(options.src + '/index.html');

					case 11:
						if (!_context2.sent) {
							_context2.next = 15;
							break;
						}

						console.log('Found index.html');
						options.src = options.src + '/index.html';
						args.push('--open');

					case 15:
						if (options['no-config']) {
							_context2.next = 18;
							break;
						}

						_context2.next = 18;
						return Promise.all([(0, _copyConfig2.default)(options), (0, _copyConfig4.default)(options)]);

					case 18:
						if (options['no-hmr']) {
							args.push('--no-hmr');
						}
						console.log('Running dev in ' + options.src);
						cmd = 'parcel serve ' + options.src;

						(0, _childProcessPromise.spawn)(cmd, args, {
							shell: true,
							stdio: 'inherit'
						});

					case 22:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, this);
	}));

	return function dev(_x) {
		return _ref2.apply(this, arguments);
	};
}();

var _childProcessPromise = require('child-process-promise');

var _fsExtra = require('fs-extra');

var _copyConfig = require('./babel/copy-config');

var _copyConfig2 = _interopRequireDefault(_copyConfig);

var _copyConfig3 = require('./postcss/copy-config');

var _copyConfig4 = _interopRequireDefault(_copyConfig3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = dev;
//# sourceMappingURL=dev.js.map