'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var renamePackage = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(options) {
		var pkg;
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.next = 2;
						return (0, _fsExtra.pathExists)('package.json');

					case 2:
						if (_context.sent) {
							_context.next = 4;
							break;
						}

						return _context.abrupt('return', console.log('No package.json file found'));

					case 4:
						console.log('Renaming in package.json file...');
						_context.next = 7;
						return (0, _fsExtra.readJson)('package.json');

					case 7:
						pkg = _context.sent;

						if (pkg.name) {
							options.oldName = pkg.name;
							pkg.name = options.name;
							recursiveReset(options, pkg);
						}
						_context.next = 11;
						return (0, _fsExtra.outputJson)('package.json', pkg, { spaces: 2 });

					case 11:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, this);
	}));

	return function renamePackage(_x) {
		return _ref.apply(this, arguments);
	};
}();

var renameServerless = function () {
	var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(options) {
		var config, i, line;
		return _regenerator2.default.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						_context2.next = 2;
						return (0, _fsExtra.pathExists)('serverless.yml');

					case 2:
						if (_context2.sent) {
							_context2.next = 4;
							break;
						}

						return _context2.abrupt('return', console.log('No serverless.yml file found'));

					case 4:
						console.log('Renaming in serverless config...');
						_context2.next = 7;
						return (0, _fsExtra.readFile)('serverless.yml');

					case 7:
						config = _context2.sent;

						config = config.toString();
						config = config.split('\n');
						i = 0;

					case 11:
						if (!(i < config.length)) {
							_context2.next = 19;
							break;
						}

						line = config[i];

						if (!(line.indexOf('service:') === 0)) {
							_context2.next = 16;
							break;
						}

						config[i] = 'service: ' + (options.name || (0, _path.basename)(process.cwd()));
						return _context2.abrupt('break', 19);

					case 16:
						i++;
						_context2.next = 11;
						break;

					case 19:
						config = config.join('\n');
						_context2.next = 22;
						return (0, _fsExtra.outputFile)('serverless.yml', config);

					case 22:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, this);
	}));

	return function renameServerless(_x2) {
		return _ref2.apply(this, arguments);
	};
}();

var rename = function () {
	var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(options) {
		return _regenerator2.default.wrap(function _callee3$(_context3) {
			while (1) {
				switch (_context3.prev = _context3.next) {
					case 0:
						if (!options.name) {
							options.name = (0, _path.basename)(process.cwd());
						}
						_context3.next = 3;
						return Promise.all([renamePackage(options), renameServerless(options)]);

					case 3:
					case 'end':
						return _context3.stop();
				}
			}
		}, _callee3, this);
	}));

	return function rename(_x3) {
		return _ref3.apply(this, arguments);
	};
}();

var _path = require('path');

var _fsExtra = require('fs-extra');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function recursiveReset(options, obj) {
	for (var i in obj) {
		if (i === 'dependencies' || i === 'devDependencies') {
			continue;
		}
		if (typeof obj[i] === 'object') {
			obj[i] = recursiveReset(options, obj[i]);
		} else {
			obj[i] = obj[i].replace(options.oldName, options.name);
		}
	}
	return obj;
}

exports.default = rename;
//# sourceMappingURL=rename.js.map